## START: Set by rpmautospec
## (rpmautospec version 0.2.5)
%define autorelease(e:s:pb:) %{?-p:0.}%{lua:
    release_number = 4;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{?dist}
## END: Set by rpmautospec

%global npm_name fx-completion

Name:           %{npm_name}
Version:        1.0.5
Release:        %autorelease -b 2
Summary:        Shell completion for fx

License:        MIT
URL:            https://github.com/antonmedv/%{npm_name}
Source0:        https://registry.npmjs.org/%{npm_name}/-/%{npm_name}-%{version}.tgz
# Because:
#   - the sole dependency to be bundled (directly) is fx
#   - fx is already packaged as a command-line utility
#   - this package is closely related to fx
# we bypass nodejs-packaging-bundler and just symlink the existing fx package.

# Hand-written downstream man page in groff_man(7) format
Source1:        %{npm_name}.1

ExclusiveArch:  %{nodejs_arches} noarch
BuildArch:      noarch

BuildRequires:  nodejs-devel
BuildRequires:  symlinks

BuildRequires:  pkgconfig(bash-completion)
%global bashcompdir %(pkg-config --variable=completionsdir bash-completion 2>/dev/null)
%global bashcomproot %(dirname %{bashcompdir} 2>/dev/null)

BuildRequires:  npm(fx)

Requires:       nodejs
Requires:       npm(fx)

%description
%{summary}.

The completions are installed system-wide.

Currently, bash is the only supported shell.


%prep
%setup -q -n package
# Copy in the man page.
cp -p '%{SOURCE1}' .

# Fix shebang lines in executables. For some reason, brp-mangle-shebangs does
# not seem to do this under %%nodejs_sitelib.
find . -type f -perm /0111 -exec gawk \
    '/^#!\/usr\/bin\/env[[:blank:]]/ { print FILENAME }; { nextfile }' \
    '{}' '+' |
  xargs -r sed -r -i '1{s|^(#!/usr/bin/)env[[:blank:]]+([^[:blank:]]+)|\1\2|}' \


%install
install -d '%{buildroot}%{nodejs_sitelib}/%{npm_name}'
cp -rp \
    package.json \
    *.js \
    *.sh \
    '%{buildroot}%{nodejs_sitelib}/%{npm_name}'

install -d '%{buildroot}%{bashcompdir}'
ln -s '%{buildroot}%{nodejs_sitelib}/%{npm_name}/complete.sh' \
    '%{buildroot}%{bashcompdir}/fx.bash'
symlinks -c -o '%{buildroot}%{bashcompdir}/fx.bash'

install -d '%{buildroot}%{nodejs_sitelib}/%{npm_name}/node_modules_prod'
ln -s '../../fx' '%{buildroot}%{nodejs_sitelib}/%{npm_name}/node_modules_prod'
ln -s 'node_modules_prod' \
    '%{buildroot}%{nodejs_sitelib}/%{npm_name}/node_modules'

install -d '%{buildroot}%{_bindir}'
# Create an absolute symlink in the buildroot, then convert it to a relative
# one that will still resolve after installation. Otherwise, to create a
# relative symlink, we would have to know how deeply nested %%nodejs_sitelib
# is, which breaks the abstraction of using a macro.
ln -s '%{buildroot}%{nodejs_sitelib}/%{npm_name}/index.js' \
    '%{buildroot}%{_bindir}/%{npm_name}'
symlinks -c -o '%{buildroot}%{_bindir}/%{npm_name}'

install -t '%{buildroot}%{_mandir}/man1' -D -p -m 0644 '%{npm_name}.1'


%check
# We do not call:
# %%{__nodejs} -e 'require("./")'
# because this package does not provide an importable module. See the lack of a
# "main" or "module" key in package.json.

# There are also no upstream tests.

# Smoke test: emit the completion script for bash
# Need a temporary symlink to the build environment’s fx from the buildroot
ln -s '%{nodejs_sitelib}/fx' '%{buildroot}%{nodejs_sitelib}/fx'
'%{buildroot}%{_bindir}/%{npm_name}' --bash
rm -vf '%{buildroot}%{nodejs_sitelib}/fx'


%files
%doc README.md
%license LICENSE
%{nodejs_sitelib}/%{npm_name}
%{_bindir}/%{npm_name}
%{_mandir}/man1/%{npm_name}.1*
# Note that it is standard in Fedora for packages providing shell completions
# to co-own the completions directory in lieu of having a runtime dependency on
# the relevant shell completions package.
%{bashcomproot}


%changelog
* Sat Aug 28 2021 Benjamin A. Beasley <code@musicinmybrain.net> 1.0.5-5
- Faster shebang fix

* Wed Jul 21 2021 Fedora Release Engineering <releng@fedoraproject.org> 1.0.5-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Sun Jul 04 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 1.0.5-2
- Fix License field

* Wed Jun 23 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 1.0.5-1
- Initial package

